define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var biz = require("$UI/system/lib/biz");
	var common = require("$UI/common/js/common");
	var util = require("$UI/system/components/justep/common/common");
	var attFlag1 = 1;
	var Model = function() {
		this.callParent();
	};

	Model.prototype.input1Click = function(event) {
		this.comp("windowDialog1").open();
	};

	// 后台获取商机报备编号
	Model.prototype.mainDataBeforeSave = function(event) {
		var reportNo = this.comp("mainData").getValue("reportNo");
		if (reportNo === null || reportNo === "" || reportNo === undefined) {
			var result = biz.Request.sendBizRequest({
				"context" : this.getContext(),
				"directExecute" : true,
				"action" : "getReportNo"
			});
			var report = result.responseJSON.data.value;

			this.comp("mainData").setValue("reportNo", report);
		}

		if (attFlag1 == 1) {

		} else {
			var message = this.comp("messageDialog1");
			message.show({
				"type" : "OK",
				"title" : "提示信息",
				"message" : "附件未上传完毕，请耐心等待。"
			});
			event.cancel = true;
		}
	};

	Model.prototype.modelLoad = function(event) {
		var mainData = this.comp("mainData");
		if (mainData.getValue("fProcessID")) {
			var FPROCESSID = mainData.getValue("fProcessID");
			var params = {
				data : FPROCESSID
			};
			var wC = this.comp("windowContainer1");
			wC.setParams(params);
			wC.refresh();
		}
	};

	/**
	 * 判断是否审批环节 true：是 false：否
	 */
	Model.prototype.isShenPi = function(event) {
		if (this.getContext().getActivity() == "mainActivity" || this.getContext().getActivity() == "applyBusinessReport") {
			return false;
		}
		return true;
	};

	/**
	 * 是否申请人已办任务 true:是 false：否
	 * 
	 * @param event
	 */
	Model.prototype.isApplyDoneTask = function(event) {
		if (this.getContext().getRequestParameter("_pagePattern") == "readonly") {
			if (this.getContext().getCurrentPersonID() == this.comp("mainData").getValue("fCreatePersonID")) {
				return true;
			} else {
				return false;
			}
		}
	};

	// 撤回按钮
	Model.prototype.button6Click = function(event) {
		var task = this.comp("process").get("task");
		var mainData = this.comp("mainData");
		var taskID = this.getContext().getTask();
		var activity = this.getContext().getActivity();
		// 判断能否回撤
		if (!this.isApplyDoneTask()) {
			alert("无法撤销");
			return;
		}
		var params = new biz.Request.ActionParam();
		params.setString("task", taskID);
		var processControl;
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"dataType" : "application/json",
			"contentType" : "application/json",
			"action" : "externalDrawBackQueryAction",
			"parameters" : params,
			"executor" : this.getContext().getCurrentPersonID(),
			"callback" : function(callbackData) {
				callbackData.ignoreError = false;
				if (callbackData.state) {
					// alert(JSON.stringify(callbackData.response));
					processControl = callbackData.response;
				}
			}
		});

		var options = new biz.Request.ActionParam();
		var objectParam = new biz.Request.ObjectParam(processControl.object, "com.justep.system.process.ProcessControl");
		options.setObject("control", objectParam);
		options.setString("task", taskID);
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"dataType" : "application/json",
			"contentType" : "application/json",
			"action" : "externalDrawBackAction",
			"parameters" : options,
			"executor" : this.getContext().getCurrentPersonID(),
			"callback" : function(callbackData) {
				callbackData.ignoreError = false;
				if (callbackData.state) {
					alert("撤销成功");
				} else {
					alert("撤销失败");
				}
			}
		});
	};

	Model.prototype.province = function(p, dept) {
		var c = "";
		if (p == '江苏') {
			c = '铁塔院 建筑院 系统集成公司 工程院 通信院 移动院 网络院';
		}
		if (p == '云南' || p == '贵州') {
			c = '西南咨询设计研究院';
		}
		if (p == '四川' || p == '西藏' || p == '青海' || p == '重庆') {
			c = '华西院';
		}
		if (p == '广东' || p == '广西' || p == '福建' || p == '浙江' || p == '海南' || p == '湖南' || p == '江西') {
			c = '华南院';
		}
		if (p == '山东' || p == '山西' || p == '内蒙古' || p == '河北' || p == '河南' || p == '黑龙江' || p == '吉林' || p == '辽宁' || p == '内蒙古自治区') {
			c = '北方院';
		}
		if (p == '上海' || p == '湖北') {
			c = '网络院';
		}
		if (p == '甘肃' || p == '陕西' || p == '安徽' || p == '宁夏' || p == '北京') {
			c = '移动院';
		}
		if (p == '新疆' || p == '天津') {
			c = '通信研究院';
		}
		// 不符合本部门的给予提示
		if (c != dept) {
			this.comp("button7").set({
				"label" : "该省份负责部门为：" + c
			});
		} else if (c == dept || c == "") {
			this.comp("button7").set({
				"label" : ""
			});
		}
	};

	Model.prototype.mainDataValueChanged = function(event) {
		var dept = this.comp("mainData").getValue("fCreateDeptName");
		var prjCity = this.comp("mainData").getValue("prjCity");
		var masterName = this.comp("mainData").getValue("masterName");
		var fid = this.comp("mainData").getValue("BID_BUSINESSREPORT");
		if (event.col == 'prjProvince') {
			var p = event.value;
			this.province(p, dept);
		}
		if (event.col == 'masterName') {
			if (prjCity && masterName) {
				var params = {
					city : prjCity,
					master : masterName,
					id : fid
				};
				var wC = this.comp("windowContainer2");
				wC.setParams(params);
				wC.refresh();
			}
		}
	};

	Model.prototype.canLook = function(event) {
		var mType = this.comp("mainData").getValue("mType");
		if (mType === '政企') {
			return true;
		} else {
			return false;
		}
	};

	Model.prototype.mainDataAfterRefresh = function(event) {
		var dept = this.comp("mainData").getValue("fCreateDeptName");
		var p = this.comp("mainData").getValue("prjProvince");
		if (p !== null && p !== undefined && p !== "") {
			this.province(p, dept);
		}

		if (this.getContext().getActivity() == "directorApproval") {
			var prjCity = this.comp("mainData").getValue("prjCity");
			var masterName = this.comp("mainData").getValue("masterName");
			var fid = this.comp("mainData").getValue("BID_BUSINESSREPORT");
			if (prjCity && masterName) {
				var params = {
					city : prjCity,
					master : masterName,
					id : fid
				};
				var wC = this.comp("windowContainer2");
				wC.setParams(params);
				wC.refresh();
			}
		}
	};
	Model.prototype.bussinessManager = function(event) {
		// 业务类别为“自建项目”且项目类型为“工程施工、系统集成、总包项目”或“商品销售”或“合同能源管理、BOT”之一，且预估收入（万元）≥3000
		// 业务类别为“自建项目”且项目类型非“工程施工、系统集成、总包项目”或“商品销售”或“合同能源管理、BOT”之一，且预估收入（万元）≥1000
		var code = this.comp("mainData").getValue("prjTypeCode");// 项目类型编号
		var undertakeWay = this.comp("mainData").getValue("undertakeWay");// 业务类别
		var eInvest = this.comp("mainData").getValue("eInvest");// 预估收入ata.ref("isManager")
		var isManager = this.comp("mainData").getValue("isManager");
		// if (this.getContext().getActivity() == "directorApproval" ) {
		if (undertakeWay == "自建项目") {
			if (code == "GC" || code == "SP" || code == "BO") {
				if (eInvest >= 3000) {
					return true;
				}
			} else {
				if (eInvest >= 1000) {
					return true;
				}
			}
		}
		// }
	};

	// 用来检测用户名是否符合要求
	Model.prototype.RegCheckName = function(name) {
		name = name.replace(/\s*/g, "");
		// 去掉空格后入个全部是数字，那么不符合要求
		var pat_num = /(^-?[0-9]+\.{1}\d+$)|(^-?[1-9][0-9]*$)|(^-?0{1}$)/;
		if (pat_num.test(name)) {
			return false;
		} else {
			if (name == undefined || name.length == 0) {
				return false;
			} else {
				return true;
			}
		}
	}

	// 在发起时进行检验 5571 优化
	Model.prototype.StartCommitCheck = function(event) {
		var activity = this.getContext().getActivity();
		if (!(activity == "mainActivity" || activity == "applyBusinessReport")) {
			return true;// 审批页面不检查此函数内容
		}

		var res = true;
		var tip = "";

		// 检验业主、联系方式、联系人的有效性
		var mainData = this.comp("mainData");
		var masterName = mainData.getValue('masterName');
		var fContactType = mainData.getValue('fContactType');
		var fContactName = mainData.getValue('fContactName');
		var BIDAGENCYCONTACTNAME = mainData.getValue("BIDAGENCYCONTACTNAME");
		var BIDAGENCYCONTACTTYPE = mainData.getValue("BIDAGENCYCONTACTTYPE");

		if (!this.RegCheckName(masterName)) {
			tip = tip + "业主名称不合规范，不能全部为数字;";
			res = false;
		}
		if (!this.RegCheckName(BIDAGENCYCONTACTNAME)) {
			tip = tip + "招标代理联系人姓名不合规范，不能全部为数字;";
			res = false;
		}
		if (!this.RegCheckName(fContactName)) {
			tip = tip + "业主联系人姓名不合规范，不能全部位数字;";
			res = false;
		}
		var pat_tel = /^(\d3,4|\d{3,4}-)?\d{7,8}$/;
		// var pat_phone=/^1[35]\d{9}$/;
		var pat_phone = /^1\d{10}$/; // 5571 修订手机号的校验，第2位数字不一定是3或者5，现在已经逐步放开
		if (!pat_tel.test(fContactType) && !pat_phone.test(fContactType)) {
			tip = tip + "业主联系方式不合规范，手机号要是1开头，11位的数据，固话可含有3-4位数字的区号，带上7-8位数字的电话号码，如果两部分都具备要用-相连;";
			res = false;
		}
		if (!pat_tel.test(BIDAGENCYCONTACTTYPE) && !pat_phone.test(BIDAGENCYCONTACTTYPE)) {
			tip = tip + "招标代理联系方式不合规范，手机号要是1开头，11位的数据，固话可含有3-4位数字的区号，带上7-8位数字的电话号码，如果两部分都具备要用-相连;";
			res = false;
		}
		
		if (tip.length > 0) {
			this.comp("messageDialog1").show({
				'message' : tip
			});
		}

		return res;
	}

	Model.prototype.advanceBtnClick = function(event) {
		debugger;
		if (!this.StartCommitCheck(event)) {
			return;
			event.cancel = true;
		}

		var flag = true;
		var flag2 = true;
		var date = this.comp("mainData");
		date.saveData();
		var fCreateDeptName = this.comp("mainData").getValue("fCreateDeptName");
		var isManager = this.comp("mainData").getValue("isManager");
		var managerName = this.comp("mainData").getValue("managerName");
		if (fCreateDeptName != "集团客户部" && fCreateDeptName != "市场部" && fCreateDeptName != "北京分公司") {
			var undertakeWay = this.comp("mainData").getValue("undertakeWay");
			if (undertakeWay != "C2") {
				flag = false;
			}
		}
		if (this.getContext().getActivity() == "directorApproval") {

			if (this.bussinessManager() && isManager == "是" && (managerName == null || managerName == "")) {
				this.comp("messageDialog1").show({
					'message' : "项目经理不能为空！"
				});
				flag2 = false;
			}
		}
		if (flag2) {
			if (true) {
				var code = this.getApprovelPerson(event)
				if (code != null) {
					date.setValue("approvalPerson", code);
				}

				this.comp("process").advanceQuery();
			} else {
				this.comp("messageDialog1").show({
					'message' : "非集客部，市场部，北京分公司人员不得发起投标类别为C2类以外的流程"
				});

			}
		}

	};
	Model.prototype.getApprovelPerson = function(event) {
		debugger;
		var date = this.comp("mainData");
		var fCreateDeptName = this.comp("mainData").getValue("fCreateDeptName");
		var mType = this.comp("mainData").getValue("mType");
		var Trade = this.comp("mainData").getValue("Trade");
		if (fCreateDeptName == "建筑规划设计研究院" || fCreateDeptName == "建筑方案创作中心") {
			return "商机报备（建筑）";// 邬明海
		} else {
			if (mType == "政企") {
				if (Trade == "电力") {
					return "商机报备（电力）";// 刘青
				} else if (Trade == "公安武警") {
					return "商机报备（公安武警）";// 王吉
				} else if (Trade == "通管局") {
					return "商机报备（通管局）";// 袁钦
				} else if (Trade == "广电") {
					return "商机报备（广电）";// 袁钦，房磊，薄晶，徐刚，仇隽
				} else {
					return "商机报备（其他）";// 房磊，薄晶，徐刚，仇隽
				}
			} else if (mType == "电信" || mType == "联通" || mType == "移动" || mType == "铁塔公司" || mType == "海外") {
				return "商机报备（通管局）";// 袁钦
			} else {
				return "商机报备（其他）";// 房磊，薄晶，徐刚，仇隽
			}
		}
	};
	Model.prototype.resultFilteUploadStart = function(event) {
		attFlag1 = 0;
	};

	Model.prototype.resultFilteUploadSuccess = function(event) {
		attFlag1 = 1;
	};

	Model.prototype.mainDataAfterNew = function(event) {
		var personID = this.getContext().getCurrentPersonID();
		var params = new biz.Request.ActionParam();
		params.setString("personID", personID);
		var result = biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"directExecute" : true,
			"parameters" : params,
			"action" : "searchUnitinfo"
		});
		var arr = result.responseJSON.data.value;
		this.comp("mainData").setValue("accountUnit", arr[0]);
		this.comp("mainData").setValue("accountUnitCode", arr[1]);
	};

	Model.prototype.input3Click = function(event) {
		this.comp("windowDialog2").open();
	};
	/**
	 * 判断是否审批环节 true：是 false：否
	 */
	Model.prototype.isShenPiOrNot = function(event) {
		if (this.getContext().getActivity() == "mainActivity" || this.getContext().getActivity() == "applyBusinessReport") {
			return true;
		}
		return false;
	};

	Model.prototype.cooUnitQReceive = function(event) {
		// alert(event.data.id+event.data.name);
		this.comp("mainData").setValue("managerCode", event.data.id);
		this.comp("mainData").setValue("managerName", event.data.name);
		this.comp("mainData").saveData();
		// this.comp("mainData").refreshData();
		// alert(this.comp("mainData").getValue("managerName"));
	};
	Model.prototype.bussinessManager = function(event) {
		debugger;
		// 业务类别为“自建项目”且项目类型为“工程施工、系统集成、总包项目”或“商品销售”或“合同能源管理、BOT”之一，且预估收入（万元）≥3000
		// 业务类别为“自建项目”且项目类型非“工程施工、系统集成、总包项目”或“商品销售”或“合同能源管理、BOT”之一，且预估收入（万元）≥1000
		if (this.getContext().getActivity() != "directorApproval") {
			return;
		}
		var data = this.comp("mainData");
		var code = data.getValue("prjTypeCode");// 项目类型编号
		var undertakeWay = data.getValue("undertakeWay");// 业务类别
		var eInvest = data.getValue("eInvest");// 预估收入ata.ref("isManager")
		var isManager = data.getValue("isManager");
		// if (this.getContext().getActivity() == "directorApproval" ){
		if (undertakeWay == "自建项目") {
			if (code == "GC" || code == "SP" || code == "BO") {
				if (eInvest >= 3000) {
					return true;
				}
			} else {
				if (eInvest >= 1000) {
					return true;
				}
			}
		}
		// }else{
		// return false;
		// }
	};
	Model.prototype.input11_2Click = function(event) {
		this.comp("cooUnitQ").open();
	};

	// 5847 商机报备字段调整 鼠标悬停提示
	// 预算拨款：由国家财政预算拨给建设单位用于建设的资金
	// 自筹资金：由地方财政、各主管部门和各单位自行筹集并经批准拨给建设单位的
	Model.prototype.gridSelect6ShowOption = function(event) {
		debugger;
		var gridselect = event.source;// 获取gridselect组件
		var grid = gridselect.grid;// 获取gridSelect组件内部的grid
		grid.on('onCellRender', function(event) {// 使用on方法添加onCellRender事件
			if (event.colName == "moneyFrom") {
				var value = event.colVal;
				var title = "";
				// 设置鼠标悬停时显示的内容
				if (value == "预算拨款") {
					title = "由国家财政预算拨给建设单位用于建设的资金";
				}
				if (value == "自筹资金") {
					title = "由地方财政、各主管部门和各单位自行筹集并经批准拨给建设单位的";
				}
				event.html = "<div title='" + title + "'>" + value + "</div>"
			}
		});
		grid.reload();
	};

	return Model;
});